// Prof Simo - DAINF/UTFPR - Ctba - TecProg S71 - 1 Sem 2022 - 1a Parcial
// Hah couts suplementares para fins de entedimento da execuo.

#include <vector>
#include <iostream>
using namespace std;

#include <stdlib.h>
#include <time.h>

#define max_andares 5

class Sensor
{
    protected:

        static vector<Sensor*> colecao_sensores; // deixei privado para melhorar segurana.

    protected:
        static int cont;
        bool ativo;

    public:

        Sensor(): ativo(true)
        {
            cont++;

            time_t t;     // https://pt.wikipedia.org/wiki/Time_t
            // Para funo srand e rand vide: https://www.tutorialspoint.com/c_standard_library/c_function_srand.htm

            srand((unsigned) time(&t));
            int result = rand()%10;    // https://www.cprogressivo.net/2013/03/Como-gerar-numeros-aleatorios-em-C-com-a-rand-srand-e-seed.html
            if (result == 0) { ativo = false; }

            //incluirSensor(this);

            //if ((int)(colecao_sensores.size()) == 0) { colecao_sensores.clear(); }
        }

        virtual ~Sensor()
        {
            ativo = false;

            int pos = 0;
            for (int i = 0; i < (int)colecao_sensores.size(); i++)
            {
                if (this == colecao_sensores[i])
                {
                    cout << endl << " ************** Achei "  << colecao_sensores[i] << " e retirei do vector" << endl;
                    static vector<Sensor*>::iterator it;
                    it = colecao_sensores.begin()+pos;
                    colecao_sensores.erase(it);
                    cout << " ************** Novo Size: "  << (int)colecao_sensores.size() << endl;
                    break;
                }
                pos++;
            }
        }

        const bool getAtivo() const { return ativo; }

        static const int TodosInativos()
        {
            for ( int i = 0; i < (int)colecao_sensores.size(); i++ )
            {
                if ( NULL != colecao_sensores[i] )  // Na vdd pode-se tirar esse if - else
                {
                    if (true == (colecao_sensores[i])->getAtivo())
                    {
                        return false;
                    }
                }
                else
                {
                    cout << "Cuidadao - sensor nulo na coleo" << endl;
                    exit(0);
                }
            }
            return true;
        }

        static void incluirSensor(Sensor* pS)
        {
            if (pS != NULL)
            {
                colecao_sensores.push_back(pS);
            }
            else
            {
                cout << "Ponteiro de Sensor  nulo" << endl;
            }
        }

        static void percorrer()
        {
            for (int i=0; i< (int)colecao_sensores.size(); i++)
            {
                if ( NULL != colecao_sensores[i] )  // Na vdd pode-se tirar esse if - else
                {
                    (colecao_sensores[i])->operator++();
                }
                else
                {
                    // ...
                }

            }
        }

        virtual void operator++() = 0;

};

vector<Sensor*> Sensor::colecao_sensores;
int Sensor::cont(0);


class Temper : public Sensor
{
    private:
        int temperatura;

    public:

        Temper()
            : Sensor(), temperatura (cont)
        {
            cout << "O valor da temperatura eh:" << temperatura << endl;

            incluirSensor(static_cast<Sensor*>(this));
        }

        ~Temper()
        {
            temperatura = 0;
        }

        void operator++()
        {
            temperatura++;
            cout << "Novo valor da temperatura : " << temperatura << endl;
        }

        const int getTemperatura() const { return temperatura; }
};

class Presen : public Sensor
{
    private:
        Temper* pTemper;
        bool    alguem;

    public:
        Presen() :
            Sensor(),
            pTemper(NULL)
        {
            //(0 == cont%2) ? alguem = true : alguem = false;
            alguem = !((bool)cont%2);
            pTemper = new Temper();

            //colecao_sensores.push_back(this);
            //incluirSensor( static_cast<Sensor*>(this) );
        }

        ~Presen()
        {
            alguem = false;

            if (pTemper)
            {
                delete pTemper;
            }
            pTemper = NULL;
        }

        void setTemper(Temper* pT)
        {
            pTemper = pT;
        }

        const int getAlguem() const { return alguem; }

        const int getTemperatura() const
        {
          if (pTemper)
          {
             return pTemper->getTemperatura();
          }
          else
          {
              cout << "Erro - pTemper Nulo" << endl;
              exit(1);
          }
        }

        const bool getAmbosAtivos() const
        {
            if ( NULL == pTemper )
            {
               cout << "Erro - pTemper Nulo" << endl;
               exit(1);
            }

            if ( ativo && pTemper->getAtivo ())
            {
                return true;
            }

            return false;
        }

        void operator++()
        {
            cout << endl << "Troquei!" << endl;
            alguem = !alguem;
        }
};

class Controle_Predio;

class Controle_Andar
{
    private:
        Presen              sens_pres;
        Controle_Predio*    pCtrlPred;
        float               oxigenio;
        bool                incendio;

    public:
            Controle_Andar(float O = 100.0):
                sens_pres(),
                pCtrlPred(NULL),
                oxigenio(O),
                incendio(false)
            {

            }

            ~Controle_Andar()
            {
                pCtrlPred = NULL;
            }

            void setControlePredio(Controle_Predio* pC)
            {
                pCtrlPred = pC;
            }

            const float getOxigenio() const
            {
                return oxigenio;
            }

            const bool getIncendio() const
            {
                return incendio;
            }

            void controlar(); // mtodo  implementado depois pois depende de Controle_Predio
    };


class Controle_Predio
{
    private:
        int             temperatura;
        Controle_Andar  andares[max_andares];

    public:
        Controle_Predio(const int T = 0):
            temperatura(T),
            andares()
        {
            for (int i = 0; i < max_andares; i++)
            {
                andares[i].setControlePredio(this);
            }
            executar();
        }

        ~Controle_Predio()
        {
        }

        const int getTemperatura() const
        {
            return temperatura;
        }

        void informar_Colapso() const
        {
            cout << endl;
            if ( Sensor::TodosInativos() )
            {
                cout << "Colapso total, nenhum sensor ativo!" << endl;
            }
            else
            {
                cout << "Ainda no h colapso total pois h ao menos um sensor funcionando." << endl;
                informar_Incendio();
            }
        }

        void informar_Incendio() const
        {
            cout << endl;

            int cont_incendios      = 0;
            //int cont_desoxigenios   = 0;

            for (int i = 0; i < max_andares; i++)
            {
                if (andares[i].getIncendio())
                {
                    cont_incendios++;
                    cout << "O andar " << i + 1 << " est em incndio!" << endl;
                }

                // abaixo um cdigo suplementar.
                /*if (andares[i].getOxigenio() == 0.0)
                {
                    cont_desoxigenios++;
                    cout << "O andar " << i + 1 << " est sem oxignio!" << endl;
                }*/
            }
            cout << endl;
            cout << "H " << cont_incendios     <<  " andares em incndio!"     << endl;
            //cout << "H " << cont_desoxigenios  <<  " andares sem oxignio!"    << endl;
        }

        void executar()
        {
            for (int i = 0; i < temperatura; i++)
            {
                cout << endl;
                cout << "Percorrimento de nmero " << i << endl;

                Sensor::percorrer();

                for (int j = 0; j < max_andares; j++)
                {
                    andares[j].controlar();
                }
            }
            informar_Colapso();  // Informar incendio  chamado aqui, se for o caso.

        }
};

// Agora sim a implementao do mtodo 'controlar' de 'Controle_Andar'
void Controle_Andar::controlar()
{
    if (NULL == pCtrlPred)
    {
        cout << "Erro - pCtrlPred Nulo" << endl;
        exit(1);
    }

    if ( sens_pres.getAmbosAtivos() &&    //cout << "Ambos os sensore ativos!" << endl;
         ( sens_pres.getTemperatura() > 55 )
       )
    {

        if ( sens_pres.getAlguem() == false  )
        {
            oxigenio = 0.0;
            incendio = false;
            cout << endl << "Desoxigenao !" << endl;
        }
        else
        {
            if ( sens_pres.getTemperatura() >= pCtrlPred->getTemperatura() )
            {
                incendio = true;
                cout << endl << "Incendio !" << endl;
            }
        }
    }
}

int main ()
{
   //Controle_Predio CP1(1);
   //Controle_Predio CP2(30);
   Controle_Predio CP3(51);
   return 0;
}

